/*
*  ASEthernetInfoRetriever.h
*  ActivationTest
*
*  Created by Ken Sillart on 3/11/09.
*  Copyright 2009 MYOB Technology Pty. Ltd.. All rights reserved.
*
*/

#pragma once

#include "ASObject.h"

namespace ASFoundation
{
	class EXTERNAL_API ASEthernetInfoRetriever : public ASObject
	{
	public:
		enum 
		{
			kNoEthernetInterfacesFoundErrorId = 1,
			kNoMACAddressesFoundErrorId
		};
		
		static ASEthernetInfoRetriever* Create(void);
		virtual ~ASEthernetInfoRetriever(void);

		virtual CPString GetPrimaryMACAddress(void);

		virtual CPArray GetEthernetInterfaces(void) = 0;
		virtual CPString GetMACAddress(const CPObject& InternetInterface) = 0;
		
	protected:
		ASEthernetInfoRetriever(void);
	};
}
