/*
*  ASHttpConnection.h
*  ActivationTest
*
*  Created by Ken Sillart on 3/4/09.
*  Copyright 2009 MYOB Technology Pty. Ltd.. All rights reserved.
*
*/

#pragma once

#include "CrossPlatform/CrossPlatform.h"
#include "ASObject.h"

namespace ASFoundation
{
	class EXTERNAL_API ASHttpConnection : public ASObject
	{
	public:
		static ASHttpConnection* Create(void);
		static CPString HTTPMethodPOST(void);
		static CPString HTTPMethodGET(void);
		static CPString HTTPMethodDELETE(void);

		virtual ~ASHttpConnection(void);

		bool IsSecured(void) const;
		void SetIsSecured(bool IsSecured);
		bool EncodeUrl(void) const;
		void SetEncodeUrl(bool EncodeUrlString);
		CPString Address(void) const;
		void SetAddress(CPString Address);
		CPString Page(void) const;
		void SetPage(CPString Page);
		CPString URL(void) const;
		void SetURL(CPString Url);
		CPString UserAgent(void) const;
		void SetUserAgent(CPString UserAgent);
		CPData Body(void) const;
		void SetBody(CPData Body);
		CPDictionary Parameters(void) const;
		CPString ParametersAsString(void) const;
		void AddParameter(CPString ParameterName, CPString ParameterValue);
		
		void AddHeaderFieldWithValue(CPString HeaderField, CPString HeaderValue);
		CPDictionary HeaderFields(void) const;

		// changed api slightly
		virtual CPData SendSynchronousRequest(void) = 0;
		//	virtual CPData DoPost(void) = 0; 
		//	virtual CPData DoGet(void) = 0;
		//	virtual CPError DoPost(void) = 0;
		//	virtual CPError DoGet(void) = 0;
		//	virtual const CPString& GetResultBuffer(void) = 0;
		//	virtual long GetLastConnectionError(void);
		virtual unsigned long TimeoutInterval(void) const;
		virtual void SetTimeoutInterval(unsigned long TimeoutIntervalInSeconds);

		CPString HTTPMethod(void) const;
		void SetHTTPMethod(CPString HttpMethod);

	protected:
		unsigned long m_TimeoutIntervalInSeconds;
		bool m_IsSecured;
		//  Pull this out later - client should do encoding - time constraint now
		bool m_encodeUrl;
		CPString m_HttpMethod;
		CPString m_Address;
		CPString m_Page;
		CPString m_Url;
		CPString m_UserAgent;
		CPData m_Body;
		CPDictionary m_Parameters;
		CPDictionary m_HeaderFields;

		ASHttpConnection(void);
	};
}
