///////////////////////////////////////////////////////////////////////////////////
//  ASXmlEncoder.h
//    Encode XML. 
//
//  Written by: Acclivity Group LLC 
//
//  Copyright:  (c) 2011 by Acclivity Group LLC, all rights reserved.
//
//  Change History (most recent first): 
//
//  05/31/11  S.M.T.  Created file.
//
///////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "ASObject.h"

namespace ASFoundation
{
	class EXTERNAL_API ASXmlEncoder : public ASObject
	{
	public:
		ASXmlEncoder();
		~ASXmlEncoder(); 
		
		// Comments can be added anywhere, but if a document is to be 
		// created with a declaration, the StartDocumentWithDeclaration must
		// be called before adding any other parents or children
		CPError  StartDocumentWithDeclaration(const CPString xmlDeclaration);
		CPError  EndXmlDocument();
		CPError  StartParentWithTag(const CPString xmlParentTag);
		CPError  EndParentWithTag(const CPString xmlParentTag);
		CPError  AddChildElementWithTag(const CPString xmlChildElement, const CPString xmlTag);
		CPError  AddComment(const CPString commentString);
		CPError  SetXmlDocument(const CPString xmlString);
		CPString GetXmlDocument();
		
	private:
		CPString CreateStartTag(const CPString xmlStartTag, bool includeLineFeed);
		CPString CreateEndTag(const CPString xmlEndTag, bool includeIndentLevel);
		CPString CreateCommentStart(void);
		CPString CreateCommentEnd(void);
		
		int      m_indentLevel;
		char     m_lineFeed[2];
		CPString m_xmlDocument;
		CPString m_xmlEndDeclaration;
	};
}
