////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  CPBool.h
//    Cross-platform boolean class.
//
//  Copyright (C) 2009 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	10/20/09  K.L.S.  Created File.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/CPObject.h"

#ifndef NO
#define NO false
#endif
#ifndef YES
#define YES true
#endif

class EXTERNAL_API CPBool : public CPObject
{
public:
	static CPString ClassType(void);

	static const CPBool False(void);
	static const CPBool True(void);
	static const CPBool No(void);
	static const CPBool Yes(void);

	CPBool(void);
	CPBool(CPId);
	CPBool(bool);
	CPBool(char);
	CPBool(unsigned char);
	CPBool(short);
	CPBool(unsigned short);
	CPBool(int);
	CPBool(unsigned int);
	CPBool(long);
	CPBool(unsigned long);
	CPBool(const CPBool&);
	~CPBool(void);

	const CPBool& operator=(CPId);
	const CPBool& operator=(char);
	const CPBool& operator=(unsigned char);
	const CPBool& operator=(short);
	const CPBool& operator=(unsigned short);
	const CPBool& operator=(int);
	const CPBool& operator=(unsigned int);
	const CPBool& operator=(long);
	const CPBool& operator=(unsigned long);
	const CPBool& operator=(bool);
	const CPBool& operator=(const CPBool&);

	bool operator==(bool) const;
	bool operator==(CPBool) const;
	bool operator==(char) const;
	bool operator==(unsigned char)const;
	bool operator==(short) const;
	bool operator==(unsigned short) const;
	bool operator==(int) const;
	bool operator==(unsigned int) const;
	bool operator==(long) const;
	bool operator==(unsigned long) const;

	bool operator!=(bool) const;
	bool operator!=(CPBool) const;
	bool operator!=(char) const;
	bool operator!=(unsigned char)const;
	bool operator!=(short) const;
	bool operator!=(unsigned short) const;
	bool operator!=(int) const;
	bool operator!=(unsigned int) const;
	bool operator!=(long) const;
	bool operator!=(unsigned long) const;

	operator bool(void) const;
	bool operator!(void) const;

#ifdef __OBJC__
	CPBool(BOOL);
	const CPBool& operator=(BOOL);
	bool operator==(BOOL) const;
	bool operator!=(BOOL) const;

	operator BOOL(void) const;
#endif  // #ifdef __OBJC__

};

