/*
*  CPEnumerator.h
*  CrossPlatformFramework
*
*  Created by Ken Sillart on 3/30/09.
*  Copyright 2009 MYOB Technology Pty. Ltd.. All rights reserved.
*
*/

#pragma once

#include "CrossPlatform/CPObject.h"

class EXTERNAL_API CPEnumerator : public CPObject
{
public:
	static CPString ClassType(void);

	CPEnumerator(void);
	CPEnumerator(const CPEnumerator& OtherObject);

	~CPEnumerator(void);


	const CPEnumerator& operator=(const CPEnumerator& OtherObject);

	CPArray AllObjects(void) const;

	CPObject* NextObject(void); // caller owns object 
	CPString NextStringObject(void);

	virtual bool IsEmpty(void) const;
	virtual void Empty(void);

#ifdef __OBJC__
	// Define methods that will be needed only when bridging to Cocoa
	CPEnumerator(NSEnumerator* Error);

	const CPEnumerator& operator=(NSEnumerator* Error);

	operator NSEnumerator*() const;
#else
	CPEnumerator(const CPArray& Values);
	const CPEnumerator& operator=(const CPArray& Values);

private:
	CPUInteger m_Pos;
	CPArray m_Obj;
#endif  // #ifdef __OBJC__
};
