////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  CPInteger.h
//    Cross-platform unsigned integer class.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/18/10  K.L.S.  Created File.
//
// Notes:
//    When building 32-bit applications, NSUInteger is a 32-bit unsigned integer. A 64-bit application treats NSUInteger as a 64-bit
//    unsigned integer.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#if __LP64__
typedef long CPInteger;
#elif defined _WIN64
typedef long long CPInteger;
#else
typedef int CPInteger;
#endif
