/*
*  CPNumber.h
*  CrossPlatformFramework
*
*  Created by Ken Sillart on 4/2/09.
*  Copyright 2009 MYOB Technology Pty. Ltd.. All rights reserved.
*
*/

#pragma once

#include "CrossPlatform/CPObject.h"

class CPBool;
class CPString;

class EXTERNAL_API CPNumber : public CPObject
{
public:
	static CPString ClassType(void);

	static const CPNumber& False(void);

	int TypeOfNumber(void) const;

	CPNumber(void);
	CPNumber(const CPNumber& Number);
	CPNumber(bool Number);
	CPNumber(CPBool Number);
	CPNumber(char Number);
	CPNumber(unsigned char Number);
	CPNumber(short Number);
	CPNumber(unsigned short Number);
	CPNumber(int Number);
	CPNumber(unsigned int Number);
	CPNumber(long Number);
	CPNumber(unsigned long Number);
	CPNumber(float Number);
	CPNumber(double Number);
	CPNumber(CPId Number);

	~CPNumber(void);

	bool IsFloatType(void) const;

	const CPNumber& operator=(const CPNumber& Number);
	const CPNumber& operator=(bool Number);
	const CPNumber& operator=(CPBool Number);
	const CPNumber& operator=(char Number);
	const CPNumber& operator=(unsigned char Number);
	const CPNumber& operator=(short Number);
	const CPNumber& operator=(unsigned short Number);
	const CPNumber& operator=(int Number);
	const CPNumber& operator=(unsigned int Number);
	const CPNumber& operator=(long Number);
	const CPNumber& operator=(unsigned long Number);
	const CPNumber& operator=(float Number);
	const CPNumber& operator=(double Number);
	const CPNumber& operator=(CPId OtherObject);

	bool operator==(const CPNumber& Number) const;
	bool operator==(bool Number) const;
	bool operator==(CPBool Number) const;
	bool operator==(char Number) const;
	bool operator==(unsigned char Number)const;
	bool operator==(short Number) const;
	bool operator==(unsigned short Number) const;
	bool operator==(int Number) const;
	bool operator==(unsigned int Number) const;
	bool operator==(long Number) const;
	bool operator==(unsigned long Number) const;
	bool operator==(float Number) const;
	bool operator==(double Number) const;

	bool operator!=(const CPNumber& Number) const;
	bool operator!=(bool Number) const;
	bool operator!=(CPBool Number) const;
	bool operator!=(char Number) const;
	bool operator!=(unsigned char Number) const;
	bool operator!=(short Number) const;
	bool operator!=(unsigned short Number) const;
	bool operator!=(int Number) const;
	bool operator!=(unsigned int Number) const;
	bool operator!=(long Number) const;
	bool operator!=(unsigned long Number) const;
	bool operator!=(float Number) const;
	bool operator!=(double Number) const;

	operator CPBool(void) const;
	operator bool(void) const;
	operator char(void) const;
	operator unsigned char(void) const;
	operator short(void) const;
	operator unsigned short(void) const;
	operator int(void) const;
	operator unsigned int(void) const;
	operator long(void) const;
	operator unsigned long(void) const;
	operator float(void) const;
	operator double(void) const;

	CPString ToString(void) const;
	CPString StringValue(void) const;

#ifdef __OBJC__
	CPNumber(NSNumber* Number);
	const CPNumber& operator=(NSNumber* Number);
	bool operator==(NSNumber* Number) const;
	bool operator!=(NSNumber* Number) const;
	operator NSNumber*(void) const;
	operator BOOL(void) const;
#endif  // #ifdef __OBJC__
};
