#pragma once

#include "CrossPlatform/CPObject.h"

class CPBool;
class CPString;
class CPNumber;

class EXTERNAL_API CPValue : public CPObject
{
public:
	static CPString ClassType(void);
	static const CPValue& False(void);
	static CPValue ValueFromPointer(const void* Pointer);

	CPValue(void);
	CPValue(const CPValue& Value);
	CPValue(const CPNumber& Value);
	CPValue(bool Value);
//	CPValue(CPBool Value);
	CPValue(char Value);
	CPValue(unsigned char Value);
	CPValue(short Value);
	CPValue(unsigned short Value);
	CPValue(int Value);
	CPValue(unsigned int Value);
	CPValue(long Value);
	CPValue(unsigned long Value);
//	CPValue(float Value);
//	CPValue(double Value);
//	CPValue(const void* Value);

	~CPValue(void);

	const CPValue& operator=(const CPValue& Value);
	const CPValue& operator=(const CPNumber& Value);
	const CPValue& operator=(bool Value);
//	const CPValue& operator=(CPBool Value);
	const CPValue& operator=(char Value);
	const CPValue& operator=(unsigned char Value);
	const CPValue& operator=(short Value);
	const CPValue& operator=(unsigned short Value);
	const CPValue& operator=(int Value);
	const CPValue& operator=(unsigned int Value);
	const CPValue& operator=(long Value);
	const CPValue& operator=(unsigned long Value);
//	const CPValue& operator=(float Value);
//	const CPValue& operator=(double Value);
//	const CPValue& operator=(const void* Value);

	const CPValue& SetValueFromPointer(const void* Value);

	bool operator==(const CPValue& Value) const;
	bool operator==(const CPNumber& Value) const;
	bool operator==(bool Value) const;
//	bool operator==(CPBool Value) const;
	bool operator==(char Value) const;
	bool operator==(unsigned char Value)const;
	bool operator==(short Value) const;
	bool operator==(unsigned short Value) const;
	bool operator==(int Value) const;
	bool operator==(unsigned int Value) const;
	bool operator==(long Value) const;
	bool operator==(unsigned long Value) const;
//	bool operator==(float Value) const;
//	bool operator==(double Value) const;
//	bool operator==(const void* Value) const;

	bool operator!=(const CPValue& Value) const;
	bool operator!=(const CPNumber& Value) const;
	bool operator!=(bool Value) const;
//	bool operator!=(CPBool Value) const;
	bool operator!=(char Value) const;
	bool operator!=(unsigned char Value) const;
	bool operator!=(short Value) const;
	bool operator!=(unsigned short Value) const;
	bool operator!=(int Value) const;
	bool operator!=(unsigned int Value) const;
	bool operator!=(long Value) const;
	bool operator!=(unsigned long Value) const;
//	bool operator!=(float Value) const;
//	bool operator!=(double Value) const;
//	bool operator!=(const void* Value) const;

	operator CPBool(void) const;
	operator bool(void) const;
	operator char(void) const;
	operator unsigned char(void) const;
	operator short(void) const;
	operator unsigned short(void) const;
	operator int(void) const;
	operator unsigned int(void) const;
	operator long(void) const;
	operator unsigned long(void) const;
//	operator float(void) const;
//	operator double(void) const;
//	operator void*(void) const;
	operator CPNumber(void) const;
	void* PointerValue(void) const;
	
#ifdef __OBJC__
	CPValue(NSValue* Value);
	CPValue(BOOL Value);
	const CPValue& operator=(NSValue* Value);
	const CPValue& operator=(BOOL Value);
	operator BOOL(void) const;
	operator NSValue*(void) const;
	bool operator!=(BOOL Value) const;
	bool operator!=(NSValue* Value) const;
	bool operator==(NSValue* Value) const;
	bool operator==(BOOL Value) const;
#endif
#ifdef __COREFOUNDATION_CFBASE__
	// Define methods that will be needed only when bridging to CoreFoundation
	CPValue(CFNumberRef String);
	const CPValue& operator=(CFNumberRef Value);

	operator CFNumberRef(void) const;
#endif
	
};
