////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  OBPDFView.h
//    View component in MVC for PDF generation support.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/16/10  K.L.S.  Created file.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#import <Cocoa/Cocoa.h>

@class OBPDFViewModel;

@interface OBPDFView : NSView
{
@private
	unsigned int currentPage;
	OBPDFViewModel* pdfViewModel;
	float scalingFactor;
	BOOL scalingDisabled;
}

-(void)setModel:(OBPDFViewModel*)newViewModel;
-(float)scalingFactor;
-(void)setScalingFactor:(float)newScalingFactor;
-(BOOL)scalingDisabled;
-(void)setScalingDisabled:(BOOL)disableScaling;

@end
