////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  OBPoint.h
//    A 2-dimensional point used in the CrossPlatform function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/16/10  G.R.W.  Created file from Ken's changes
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/OBCoordinate.h"

class EXTERNAL_API OBPoint
{
public:
	static OBPoint PointWithXYCoordinates(OBCoordinate X, OBCoordinate Y);

	OBCoordinate x;
	OBCoordinate y;

	OBPoint(void);
	OBPoint(const OBPoint& Point);

	virtual ~OBPoint(void);
	
	const OBPoint& operator=(const OBPoint& Point);

#ifdef __OBJC__
	OBPoint(const NSPoint& Point);
	const OBPoint& operator=(const NSPoint& Point);
	operator NSPoint(void) const;
#endif

protected:
	OBPoint(OBCoordinate X, OBCoordinate Y);
};
