////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  OBSize.h
//    A 2-dimensional size used in the CrossPlatform function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/23/10  K.L.S.  Created file.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/OBCoordinate.h"

class EXTERNAL_API OBSize
{
public:
	static OBSize SizeWithWidthAndHeight(OBCoordinate Width, OBCoordinate Height);

	OBCoordinate width;		// should never be negative
	OBCoordinate height;	// should never be negative

	OBSize(void);
	virtual ~OBSize(void);

	OBSize(const OBSize& Size);
	const OBSize& operator=(OBSize Size);

#ifdef __OBJC__
	OBSize(NSSize Size);
	const OBSize& operator=(NSSize Size);
	operator NSSize(void) const;
#endif

protected:
	OBSize(OBCoordinate Width, OBCoordinate Height);
};
