////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  PDFFont.h
//    A Font specification used in the CrossPlatform PDF function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/16/10  G.R.W.  Created file from Ken's changes
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/OBFontSpec.h"

class EXTERNAL_API PDFFont : public OBFontSpec
{
public:	
	static PDFFont FontSpecWithNameSizeAndStyle(CPString FontName, float Size, int Style);

	PDFFont(void);
	PDFFont(const OBFontSpec& Font);
	PDFFont(const PDFFont& Font);
	~PDFFont(void);

protected:
	PDFFont(CPString Font, float Size, int Style);
};
