////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  PDFImage.h
//    A Font specification used in the CrossPlatform PDF function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/16/10  K.L.S.  Created file.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/OBImage.h"

class EXTERNAL_API PDFImage : public OBImage
{
public:
	PDFImage(void);
	~PDFImage(void);

	PDFImage(const PDFImage& Image);
	const PDFImage& operator=(const PDFImage& ImageIn);
	PDFImage(const OBImage& Image);
	const PDFImage& operator=(const OBImage& ImageIn);

#ifdef __OBJC__
	PDFImage(NSImage* Image);
	const PDFImage& operator=(NSImage* Image);
#endif
};
