////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  PDFPoint.h
//    A 2-dimensional point used in the CrossPlatform PDF function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/16/10  G.R.W.  Created file from Ken's changes
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/OBPoint.h"
#include "ObsoleteBridge/PDFCoordinate.h"

class EXTERNAL_API PDFPoint : public OBPoint
{
public:
	static PDFPoint PointWithXYCoordinates(OBCoordinate X, OBCoordinate Y);
	
	PDFPoint(void);
	PDFPoint(OBPoint PointIn);
	const PDFPoint& operator=(OBPoint PointIn);

#ifdef __OBJC__
	PDFPoint(const NSPoint& Point);
	const PDFPoint& operator=(const NSPoint& Point);
#endif
protected:
	PDFPoint(PDFCoordinate X, PDFCoordinate Y);
	
};
