////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  PDFPolygonInfo.h
//    A collection of points used for the PDF function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/30/10  K.L.S.  Created file.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/PDFPoint.h"
#include "CrossPlatform/CPData.h"
#include "CrossPlatform/CPUInteger.h"

class EXTERNAL_API PDFPolygonInfo
{
public:
	PDFPolygonInfo(void);
	virtual ~PDFPolygonInfo(void);
	
	void AddPoint(PDFPoint Point);
	PDFPoint PointAtIndex(CPUInteger Index) const;
	CPUInteger Count(void) const;
	CPData Data(void) const;
	
private:
	CPData m_Data;
	CPUInteger m_Count;
};
