////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  PDFRect.h
//    A typedef file for types used in the CrossPlatform PDF function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/16/10  G.R.W.  Added Ken's changes
//	09/14/10  G.R.W.  Created File.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/OBRect.h"
#include "ObsoleteBridge/PDFCoordinate.h"
#include "ObsoleteBridge/PDFPoint.h"
#include "ObsoleteBridge/PDFSize.h"

class EXTERNAL_API PDFRect : public OBRect
{
public:
	static PDFRect EmptyRect(void);
	static PDFRect RectWithOriginAndSize(PDFPoint Origin, PDFSize Size);
	static PDFRect RectWithXYWidthAndHeight(PDFCoordinate X, PDFCoordinate Y, PDFCoordinate Width, PDFCoordinate Height);
	
	PDFRect(void);
	PDFRect(PDFPoint Origin, PDFSize Size);
	PDFRect(OBRect RectIn);
	const PDFRect& operator=(OBRect RectIn);

protected:
	PDFRect(PDFCoordinate X, PDFCoordinate Y, PDFCoordinate Width, PDFCoordinate Height);
};
