////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  PDFSize.h
//    A 2-dimensional size used in the CrossPlatform PDF function calls.
//
//  Copyright (C) 2010 MYOB US, Inc., all rights reserved.
//
//  Change History (most recent first):
//
//	09/23/10  K.L.S.  Created file.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "CrossPlatform/ExternalAPIMacros.h"
#include "ObsoleteBridge/OBSize.h"
#include "ObsoleteBridge/PDFCoordinate.h"

class EXTERNAL_API PDFSize : public OBSize
{
public:
	static PDFSize SizeWithWidthAndHeight(OBCoordinate Width, OBCoordinate Height);

	PDFSize(void);
	PDFSize(const OBSize& SizeIn);
	PDFSize(const PDFSize& SizeIn);

	const PDFSize& operator=(const OBSize& SizeIn);
	const PDFSize& operator=(const PDFSize& SizeIn);
	
protected:
	PDFSize(PDFCoordinate Width, PDFCoordinate Height);
};
