////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  PDFUtilities.h
//    Utilites helpful for converting types associated wth PDF generation.
//
//  Copyright (C) 2010-2011 Acclivity Group LLC, all rights reserved.
//
//  Change History (most recent first):
//
//	06/26/11  K.L.S.  Added parameter to ConvertToNSRectAndAdjust.
//	09/16/10  K.L.S.  Created file.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#import <Cocoa/Cocoa.h>
#include "ObsoleteBridge/PDFCoordinate.h"

class PDFRect;
class PDFColor;
class PDFFont;

PDFCoordinate ConvertInchesToPoints(PDFCoordinate Inches);
NSColor* ConvertToNSColor(const PDFColor& ColorIn);
NSColor* ConvertToNSColor(const PDFColor* ColorIn);
NSFont* ConvertToNSFont(const PDFFont& FontIn);
NSRect ConvertToNSRect(const PDFRect& RectIn);
NSRect ConvertToNSRectAndAdjust(const PDFRect& RectIn, float adjustment);
EXTERNAL_API NSDictionary* ConvertToFontAttributes(const PDFFont& FontIn, const PDFColor& Color);
float FontVerticalSpacing(NSFont* Font);
float FontHeight(NSFont* Font);

NSParagraphStyle* GetParagraphStyle(void);
NSStringDrawingOptions StringDrawingOptions(void);
